<template>
    <div>
        <p>
            Для обновления базы данных загрузите файл расширения .sql и введите
            пароль.
        </p>

        <QuestFileInput accept=".sql" v-model="dumpData.file" /><br />
        <template v-if="dumpData.file">
            <QuestTextField
                password
                v-model="dumpData.password"
                placeholder="Пароль"
            /><br />
            <QuestBtn :disabled="!isValid" @click="dump">
                Обновить данные
            </QuestBtn></template
        >
    </div>
</template>

<script>
import QuestFileInput from "@/components/QuestFileInput";
import adminApi from "@/api/adminApi";
import QuestTextField from "@/components/QuestTextField";
import QuestBtn from "@/components/QuestBtn";
import snackbar from "@/utils/snackbar";

const initialDumpData = {
    file: null,
    password: "",
};

export default {
    name: "Dump",
    components: { QuestBtn, QuestTextField, QuestFileInput },
    data: () => ({ dumpData: { ...initialDumpData } }),
    methods: {
        async dump() {
            try {
                await adminApi.dump(this.dumpData);
                this.dumpData = { ...initialDumpData };
            } catch (e) {
                snackbar(e);
            }
        },
    },
    computed: {
        isValid() {
            return this.dumpData.file && this.dumpData.password;
        },
    },
};
</script>

<style scoped></style>
